diff -urwN -X /home/jonathan/diff/exclude.txt mdl-cvshead/lib/completion/completion_completion.php mdl20-mitms-integration/lib/completion/completion_completion.php
--- mdl-cvshead/lib/completion/completion_completion.php	1970-01-01 12:00:00.000000000 +1200
+++ mdl20-mitms-integration/lib/completion/completion_completion.php	2009-08-25 16:20:28.000000000 +1200
@@ -0,0 +1,136 @@
+<?php
+
+// This file is part of Moodle - http://moodle.org/
+//
+// Moodle is free software: you can redistribute it and/or modify
+// it under the terms of the GNU General Public License as published by
+// the Free Software Foundation, either version 3 of the License, or
+// (at your option) any later version.
+//
+// Moodle is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+//
+// You should have received a copy of the GNU General Public License
+// along with Moodle.  If not, see <http://www.gnu.org/licenses/>.
+
+
+/**
+ * Course completion status for a particular user/course
+ *
+ * @package   moodlecore
+ * @copyright 2009 Catalyst IT Ltd
+ * @author    Aaron Barnes <aaronb@catalyst.net.nz>
+ * @license   http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
+ */
+require_once($CFG->libdir.'/data_object.php');
+
+
+/**
+ * Course completion status for a particular user/course
+ */
+class completion_completion extends data_object {
+
+    /**
+     * DB Table
+     * @var string $table
+     */
+    public $table = 'course_completions';
+
+    /**
+     * Array of required table fields, must start with 'id'.
+     * @var array $required_fields
+     */
+    public $required_fields = array('id', 'userid', 'course', 'deleted', 'timenotified', 'timeenroled', 'timecompleted');
+
+    /**
+     * User ID
+     * @access  public
+     * @var     int
+     */
+    public $userid;
+
+    /**
+     * Course ID
+     * @access  public
+     * @var     int
+     */
+    public $course;
+
+    /**
+     * Set to 1 if this record has been deleted
+     * @access  public
+     * @var     int
+     */
+    public $deleted;
+
+    /**
+     * Timestamp the interested parties were notified
+     * of this user's completion
+     * @access  public
+     * @var     int
+     */
+    public $timenotified;
+
+    /**
+     * Time of course enrolment
+     * @access  public
+     * @var     int
+     */
+    public $timeenroled;
+
+    /**
+     * Timestamp of course completion
+     * @see     completion_completion::mark_complete()
+     * @access  public
+     * @var     int
+     */
+    public $timecompleted;
+
+
+    /**
+     * Finds and returns a data_object instance based on params.
+     * @static abstract
+     *
+     * @param array $params associative arrays varname=>value
+     * @return object data_object instance or false if none found.
+     */
+    public static function fetch($params) {
+        $params['deleted'] = null;
+        return self::fetch_helper('course_completions', __CLASS__, $params);
+    }
+
+    /**
+     * Return status of this completion
+     * @access  public
+     * @return  boolean
+     */
+    public function is_complete() {
+        return (bool) $this->timecompleted;
+    }
+
+    /**
+     * Mark this user complete in this course
+     * 
+     * This generally happens when the required completion criteria
+     * in the course are complete.
+     *
+     * This method creates a course_completions record
+     * @access  public
+     * @return  void
+     */
+    public function mark_complete() {
+
+        $this->timecompleted = time();
+
+        // Get users timenroled
+        // Can't find a more efficient way of doing this without alter get_users_by_capability()
+        global $DB;
+        $context = get_context_instance(CONTEXT_COURSE, $this->course);
+        $this->timeenroled = $DB->get_field('role_assignments', 'timestart', array('contextid' => $context->id, 'userid' => $this->userid));
+
+        // Create record
+        $this->insert();
+    }
+}
diff -urwN -X /home/jonathan/diff/exclude.txt mdl-cvshead/lib/completion/completion_criteria_activity.php mdl20-mitms-integration/lib/completion/completion_criteria_activity.php
--- mdl-cvshead/lib/completion/completion_criteria_activity.php	1970-01-01 12:00:00.000000000 +1200
+++ mdl20-mitms-integration/lib/completion/completion_criteria_activity.php	2009-08-25 16:20:28.000000000 +1200
@@ -0,0 +1,196 @@
+<?php
+
+// This file is part of Moodle - http://moodle.org/
+//
+// Moodle is free software: you can redistribute it and/or modify
+// it under the terms of the GNU General Public License as published by
+// the Free Software Foundation, either version 3 of the License, or
+// (at your option) any later version.
+//
+// Moodle is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+//
+// You should have received a copy of the GNU General Public License
+// along with Moodle.  If not, see <http://www.gnu.org/licenses/>.
+
+/**
+ * Course completion critieria - completion on activity completion
+ *
+ * @package   moodlecore
+ * @copyright 2009 Catalyst IT Ltd
+ * @author    Aaron Barnes <aaronb@catalyst.net.nz>
+ * @license   http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
+ */
+class completion_criteria_activity extends completion_criteria {
+
+    /**
+     * Criteria type constant
+     * @var int
+     */
+    public $criteriatype = COMPLETION_CRITERIA_TYPE_ACTIVITY;
+
+    /**
+     * Finds and returns a data_object instance based on params.
+     * @static abstract
+     *
+     * @param array $params associative arrays varname=>value
+     * @return object data_object instance or false if none found.
+     */
+    public static function fetch($params) {
+        $params['criteriatype'] = COMPLETION_CRITERIA_TYPE_ACTIVITY;
+        return self::fetch_helper('course_completion_criteria', __CLASS__, $params);
+    }
+
+    /**
+     * Add appropriate form elements to the critieria form
+     * @access  public
+     * @param   object  $mform  Moodle forms object
+     * @param   mixed   $data   optional
+     * @return  void
+     */
+    public function config_form_display(&$mform, $data = null) {
+        $mform->addElement('checkbox', 'criteria_activity['.$data->id.']', ucfirst(self::get_mod_name($data->module)).' - '.$data->name);
+
+        if ($this->id) {
+            $mform->setDefault('criteria_activity['.$data->id.']', 1);
+        }
+    }
+
+    /**
+     * Update the criteria information stored in the database
+     * @access  public
+     * @param   array   $data   Form data
+     * @return  void
+     */
+    public function update_config(&$data) {
+        global $DB;
+
+        if (!empty($data->criteria_activity) && is_array($data->criteria_activity)) {
+
+            $this->course = $data->id;
+
+            foreach (array_keys($data->criteria_activity) as $activity) {
+
+                $module = $DB->get_record('course_modules', array('id' => $activity));
+                $this->module = self::get_mod_name($module->module);
+                $this->moduleinstance = $activity;
+                $this->id = NULL;
+                $this->insert();
+            }
+        }
+    }
+
+    /**
+     * Get module instance module type
+     * @static
+     * @access  public
+     * @param   int     $type   Module type id
+     * @return  string
+     */
+    public static function get_mod_name($type) {
+        static $types;
+
+        if (!is_array($types)) {
+            global $DB;
+            $types = $DB->get_records('modules');
+        }
+
+        return $types[$type]->name;
+    }
+
+    /**
+     * Review this criteria and decide if the user has completed
+     * @access  public
+     * @param   object  $completion     The user's completion record
+     * @param   boolean $mark           Optionally set false to not save changes to database
+     * @return  boolean
+     */
+    public function review($completion, $mark = true) {
+        global $DB;
+
+        $course = $DB->get_record('course', array('id' => $completion->course));
+        $cm = $DB->get_record('course_modules', array('id' => $this->moduleinstance));
+        $info = new completion_info($course);
+
+        $data = $info->get_data($cm, false, $completion->userid);
+
+        // If the activity is complete
+        if (in_array($data->completionstate, array(COMPLETION_COMPLETE, COMPLETION_COMPLETE_PASS))) {
+            if ($mark) {
+                $completion->mark_complete();
+            }
+
+            return true;
+        }
+
+        return false;
+    }
+
+    /**
+     * Return criteria title for display in reports
+     * @access  public
+     * @return  string
+     */
+    public function get_title() {
+        return get_string('activitiescompleted', 'completion');
+    }
+
+    /**
+     * Find user's who have completed this criteria
+     * @access  public
+     * @return  void
+     */
+    public function cron() {
+        global $DB;
+
+        // Get all users who meet this criteria
+        $sql = '
+            SELECT DISTINCT
+                c.id AS course,
+                cr.date AS date,
+                cr.id AS criteriaid,
+                ra.userid AS userid
+            FROM
+                {course_completion_criteria} cr
+            INNER JOIN
+                {course} c
+             ON cr.course = c.id
+            INNER JOIN
+                {context} con
+             ON con.instanceid = c.id
+            INNER JOIN
+                {role_assignments} ra
+              ON ra.contextid = con.id
+            INNER JOIN
+                {course_modules_completion} mc
+             ON mc.coursemoduleid = cr.moduleinstance
+            AND mc.userid = ra.userid
+            LEFT JOIN
+                {course_completion_crit_compl} cc
+             ON cc.criteriaid = cr.id
+            AND cc.userid = ra.userid
+            WHERE
+                cr.criteriatype = '.COMPLETION_CRITERIA_TYPE_ACTIVITY.'
+            AND con.contextlevel = '.CONTEXT_COURSE.'
+            AND c.enablecompletion = 1
+            AND cc.id IS NULL
+            AND (
+                mc.completionstate = '.COMPLETION_COMPLETE.'
+             OR mc.completionstate = '.COMPLETION_COMPLETE_PASS.'
+                )
+        ';
+
+        // Loop through completions, and mark as complete
+        if ($rs = $DB->get_recordset_sql($sql)) {
+            foreach ($rs as $record) {
+
+                $completion = new completion_criteria_completion((array)$record);
+                $completion->mark_complete();
+            }
+
+            $rs->close();
+        }
+    }
+}
diff -urwN -X /home/jonathan/diff/exclude.txt mdl-cvshead/lib/completion/completion_criteria_completion.php mdl20-mitms-integration/lib/completion/completion_criteria_completion.php
--- mdl-cvshead/lib/completion/completion_criteria_completion.php	1970-01-01 12:00:00.000000000 +1200
+++ mdl20-mitms-integration/lib/completion/completion_criteria_completion.php	2009-08-25 16:20:28.000000000 +1200
@@ -0,0 +1,189 @@
+<?php
+
+// This file is part of Moodle - http://moodle.org/
+//
+// Moodle is free software: you can redistribute it and/or modify
+// it under the terms of the GNU General Public License as published by
+// the Free Software Foundation, either version 3 of the License, or
+// (at your option) any later version.
+//
+// Moodle is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+//
+// You should have received a copy of the GNU General Public License
+// along with Moodle.  If not, see <http://www.gnu.org/licenses/>.
+
+/**
+ * Completion data for a specific user, course and critieria
+ *
+ * @package   moodlecore
+ * @copyright 2009 Catalyst IT Ltd
+ * @author    Aaron Barnes <aaronb@catalyst.net.nz>
+ * @license   http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
+ */
+require_once($CFG->libdir.'/data_object.php');
+
+
+/**
+ * Completion data for a specific user, course and critieria
+ */
+class completion_criteria_completion extends data_object {
+
+    /**
+     * DB Table
+     * @var string $table
+     */
+    public $table = 'course_completion_crit_compl';
+
+    /**
+     * Array of required table fields, must start with 'id'.
+     * @var array $required_fields
+     */
+    public $required_fields = array('id', 'userid', 'course', 'criteriaid', 'gradefinal', 'deleted', 'unenroled', 'timecompleted');
+
+    /**
+     * User ID
+     * @access  public
+     * @var     int
+     */
+    public $userid;
+
+    /**
+     * Course ID
+     * @access  public
+     * @var     int
+     */
+    public $course;
+
+    /**
+     * The id of the course completion criteria this completion references
+     * @access  public
+     * @var     int
+     */
+    public $criteriaid;
+
+    /**
+     * The final grade for the user in the course (if completing a grade criteria)
+     * @access  public
+     * @var     float
+     */
+    public $gradefinal;
+
+    /**
+     * Course deleted flag
+     * @access  public
+     * @var     boolean
+     */
+    public $deleted;
+
+    /**
+     * Timestamp of user unenrolment (if completing a unenrol criteria)
+     * @access  public
+     * @var     int     (timestamp)
+     */
+    public $unenroled;
+
+    /**
+     * Timestamp of course criteria completion
+     * @see     completion_criteria_completion::mark_complete()
+     * @access  public
+     * @var     int     (timestamp)
+     */
+    public $timecompleted;
+
+    /**
+     * Associated criteria object
+     * @access  private
+     * @var object  completion_criteria
+     */
+    private $_criteria;
+
+    /**
+     * Finds and returns a data_object instance based on params.
+     * @static abstract
+     *
+     * @param array $params associative arrays varname=>value
+     * @return object data_object instance or false if none found.
+     */
+    public static function fetch($params) {
+        $params['deleted'] = null;
+        return self::fetch_helper('course_completion_crit_compl', __CLASS__, $params);
+    }
+
+    /**
+     * Finds and returns all data_object instances based on params.
+     * @static abstract
+     *
+     * @param array $params associative arrays varname=>value
+     * @return array array of data_object insatnces or false if none found.
+     */
+    public static function fetch_all($params) {}
+
+    /**
+     * Return status of this criteria completion
+     * @access  public
+     * @return  boolean
+     */
+    public function is_complete() {
+        return (bool) $this->timecompleted;
+    }
+
+    /**
+     * Mark this criteria complete for the associated user
+     *
+     * This method creates a course_completion_crit_compl record
+     * @access  public
+     * @return  void
+     */
+    public function mark_complete() {
+        // Create record
+        $this->timecompleted = time();
+        $this->insert();
+    }
+
+    /**
+     * Attach a preloaded criteria object to this object
+     * @access  public
+     * @param   $criteria   object  completion_criteria
+     * @return  void
+     */
+    public function attach_criteria(completion_criteria $criteria) {
+        $this->_criteria = $criteria;
+    }
+
+    /**
+     * Return the associated criteria with this completion
+     * If nothing attached, load from the db
+     * @access  public
+     * @return  object completion_criteria
+     */
+    public function get_criteria() {
+
+        if (!$this->_criteria)
+        {
+            global $DB;
+
+            $params = array(
+                'id'    => $this->criteriaid
+            );
+
+            $record = $DB->get_record('course_completion_criteria', $params);
+
+            $this->attach_criteria(completion_criteria::factory($record));
+        }
+
+        return $this->_criteria;
+    }
+
+    /**
+     * Return criteria status text for display in reports
+     * @see     completion_criteria::get_status()
+     * @access  public
+     * @return  string
+     */
+    public function get_status() {
+        return $this->_criteria->get_status($this);
+    }
+}
diff -urwN -X /home/jonathan/diff/exclude.txt mdl-cvshead/lib/completion/completion_criteria_date.php mdl20-mitms-integration/lib/completion/completion_criteria_date.php
--- mdl-cvshead/lib/completion/completion_criteria_date.php	1970-01-01 12:00:00.000000000 +1200
+++ mdl20-mitms-integration/lib/completion/completion_criteria_date.php	2009-08-25 16:20:28.000000000 +1200
@@ -0,0 +1,173 @@
+<?php
+
+// This file is part of Moodle - http://moodle.org/
+//
+// Moodle is free software: you can redistribute it and/or modify
+// it under the terms of the GNU General Public License as published by
+// the Free Software Foundation, either version 3 of the License, or
+// (at your option) any later version.
+//
+// Moodle is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+//
+// You should have received a copy of the GNU General Public License
+// along with Moodle.  If not, see <http://www.gnu.org/licenses/>.
+
+/**
+ * Course completion critieria - completion on specified date
+ *
+ * @package   moodlecore
+ * @copyright 2009 Catalyst IT Ltd
+ * @author    Aaron Barnes <aaronb@catalyst.net.nz>
+ * @license   http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
+ */
+class completion_criteria_date extends completion_criteria {
+
+    /**
+     * Criteria type constant
+     * @var int
+     */
+    public $criteriatype = COMPLETION_CRITERIA_TYPE_DATE;
+
+    /**
+     * Finds and returns a data_object instance based on params.
+     * @static abstract
+     *
+     * @param array $params associative arrays varname=>value
+     * @return object data_object instance or false if none found.
+     */
+    public static function fetch($params) {
+        $params['criteriatype'] = COMPLETION_CRITERIA_TYPE_DATE;
+        return self::fetch_helper('course_completion_criteria', __CLASS__, $params);
+    }
+
+    /**
+     * Add appropriate form elements to the critieria form
+     * @access  public
+     * @param   object  $mform  Moodle forms object
+     * @param   mixed   $data   optional
+     * @return  void
+     */
+    public function config_form_display(&$mform, $data = null)
+    {
+        $mform->addElement('checkbox', 'criteria_date', get_string('enable'));
+        $mform->addElement('date', 'criteria_date_value', get_string('afterspecifieddate', 'completion'));
+
+        // If instance of criteria exists
+        if ($this->id) {
+            $mform->setDefault('criteria_date', 1);
+            $mform->setDefault('criteria_date_value', $this->date);
+        } else {
+            $mform->setDefault('criteria_date_value', time() + 3600 * 24);
+        }
+    }
+
+    /**
+     * Update the criteria information stored in the database
+     * @access  public
+     * @param   array   $data   Form data
+     * @return  void
+     */
+    public function update_config(&$data) {
+
+        if (!empty($data->criteria_date))
+        {
+            $this->course = $data->id;
+            $date = $data->criteria_date_value;
+            $this->date = strtotime($date['Y'].'-'.$date['M'].'-'.$date['d']);
+            $this->insert();
+        }
+    }
+
+    /**
+     * Review this criteria and decide if the user has completed
+     * @access  public
+     * @param   object  $completion     The user's completion record
+     * @param   boolean $mark           Optionally set false to not save changes to database
+     * @return  boolean
+     */
+    public function review($completion, $mark = true)
+    {
+        // If date is past date
+        if ($this->date && $this->date < time()) {
+            if ($mark) {
+                $completion->mark_complete();
+            }
+
+            return true;
+        }
+
+        return false;
+    }
+
+    /**
+     * Return criteria title for display in reports
+     * @access  public
+     * @return  string
+     */
+    public function get_title() {
+        return get_string('date');
+    }
+
+    /**
+     * Return criteria status text for display in reports
+     * @access  public
+     * @param   object  $completion     The user's completion record
+     * @return  string
+     */
+    public function get_status($completion) {
+        return userdate($this->date, '%d-%h-%y');
+    }
+
+    /**
+     * Find user's who have completed this criteria
+     * @access  public
+     * @return  void
+     */
+    public function cron() {
+        global $DB;
+
+        // Get all users who match meet this criteria
+        $sql = '
+            SELECT DISTINCT
+                c.id AS course,
+                cr.date AS date,
+                cr.id AS criteriaid,
+                ra.userid AS userid
+            FROM
+                {course_completion_criteria} cr
+            INNER JOIN
+                {course} c
+             ON cr.course = c.id
+            INNER JOIN
+                {context} con
+             ON con.instanceid = c.id
+            INNER JOIN
+                {role_assignments} ra
+             ON ra.contextid = con.id
+            LEFT JOIN
+                {course_completion_crit_compl} cc
+             ON cc.criteriaid = cr.id
+            AND cc.userid = ra.userid
+            WHERE
+                cr.criteriatype = '.COMPLETION_CRITERIA_TYPE_DATE.'
+            AND con.contextlevel = '.CONTEXT_COURSE.'
+            AND c.enablecompletion = 1
+            AND cc.id IS NULL
+            AND cr.date < ?
+        ';
+
+        // Loop through completions, and mark as complete
+        if ($rs = $DB->get_recordset_sql($sql, array(time()))) {
+            foreach ($rs as $record) {
+
+                $completion = new completion_criteria_completion((array)$record);
+                $completion->mark_complete();
+            }
+
+            $rs->close();
+        }
+    }
+}
diff -urwN -X /home/jonathan/diff/exclude.txt mdl-cvshead/lib/completion/completion_criteria_duration.php mdl20-mitms-integration/lib/completion/completion_criteria_duration.php
--- mdl-cvshead/lib/completion/completion_criteria_duration.php	1970-01-01 12:00:00.000000000 +1200
+++ mdl20-mitms-integration/lib/completion/completion_criteria_duration.php	2009-08-25 16:20:28.000000000 +1200
@@ -0,0 +1,197 @@
+<?php
+
+// This file is part of Moodle - http://moodle.org/
+//
+// Moodle is free software: you can redistribute it and/or modify
+// it under the terms of the GNU General Public License as published by
+// the Free Software Foundation, either version 3 of the License, or
+// (at your option) any later version.
+//
+// Moodle is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+//
+// You should have received a copy of the GNU General Public License
+// along with Moodle.  If not, see <http://www.gnu.org/licenses/>.
+
+/**
+ * Course completion critieria - completion after specific duration from course enrolment
+ *
+ * @package   moodlecore
+ * @copyright 2009 Catalyst IT Ltd
+ * @author    Aaron Barnes <aaronb@catalyst.net.nz>
+ * @license   http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
+ */
+class completion_criteria_duration extends completion_criteria {
+
+    /**
+     * Criteria type constant
+     * @var int
+     */
+    public $criteriatype = COMPLETION_CRITERIA_TYPE_DURATION;
+
+    /**
+     * Finds and returns a data_object instance based on params.
+     * @static abstract
+     *
+     * @param array $params associative arrays varname=>value
+     * @return object data_object instance or false if none found.
+     */
+    public static function fetch($params) {
+        $params['criteriatype'] = COMPLETION_CRITERIA_TYPE_DURATION;
+        return self::fetch_helper('course_completion_criteria', __CLASS__, $params);
+    }
+
+    /**
+     * Add appropriate form elements to the critieria form
+     * @access  public
+     * @param   object  $mform  Moodle forms object
+     * @param   mixed   $data   optional
+     * @return  void
+     */
+    public function config_form_display(&$mform, $data = null) {
+
+        $mform->addElement('checkbox', 'criteria_duration', get_string('enable'));
+
+        $thresholdmenu=array();
+        for ($i=1; $i<=30; $i++) {
+            $seconds = $i * 86400;
+            $thresholdmenu[$seconds] = get_string('numdays', '', $i);
+        }
+        $mform->addElement('select', 'criteria_duration_days', get_string('daysafterenrolment', 'completion'), $thresholdmenu);
+
+        if ($this->id) {
+            $mform->setDefault('criteria_duration', 1);
+            $mform->setDefault('criteria_duration_days', $this->enrolperiod);
+        }
+    }
+
+    /**
+     * Update the criteria information stored in the database
+     * @access  public
+     * @param   array   $data   Form data
+     * @return  void
+     */
+    public function update_config(&$data) {
+
+        if (!empty($data->criteria_duration)) {
+            $this->course = $data->id;
+            $this->enrolperiod = $data->criteria_duration_days;
+            $this->insert();
+        }
+    }
+
+    /**
+     * Get the time this user was enroled
+     * @param   object  $completion
+     * @return  int
+     */
+    private function get_timeenroled($completion) {
+        global $DB;
+
+        $context = get_context_instance(CONTEXT_COURSE, $this->course);
+        return $DB->get_field('role_assignments', 'timestart', array('contextid' => $context->id, 'userid' => $completion->userid));
+    }
+
+    /**
+     * Review this criteria and decide if the user has completed
+     * @access  public
+     * @param   object  $completion     The user's completion record
+     * @param   boolean $mark           Optionally set false to not save changes to database
+     * @return  boolean
+     */
+    public function review($completion, $mark = true) {
+        $timeenroled = $this->get_timeenroled($completion);
+
+        // If duration since enrolment has passed
+        if (!$this->enrolperiod || !$timeenroled) {
+            return false;
+        }
+
+        if (time() > ($timeenroled + $this->enrolperiod)) {
+            if ($mark) {
+                $completion->mark_complete();
+            }
+
+            return true;
+        }
+
+        return false;
+    }
+
+    /**
+     * Return criteria title for display in reports
+     * @access  public
+     * @return  string
+     */
+    public function get_title() {
+        return get_string('enrolmentduration', 'completion');
+    }
+
+    /**
+     * Return criteria status text for display in reports
+     * @access  public
+     * @param   object  $completion     The user's completion record
+     * @return  string
+     */
+    public function get_status($completion) {
+        $timeenroled = $this->get_timeenroled($completion);
+        $timeleft = $timeenroled + $this->enrolperiod - time();
+        $enrolperiod = ceil($this->enrolperiod / (60 * 60 * 24));
+
+        $daysleft = ceil($timeleft / (60 * 60 * 24));
+
+        return ($daysleft > 0 ? $daysleft : 0).' of '.$enrolperiod;
+    }
+
+    /**
+     * Find user's who have completed this criteria
+     * @access  public
+     * @return  void
+     */
+    public function cron() {
+        global $DB;
+
+        // Get all users who match meet this criteria
+        $sql = '
+            SELECT DISTINCT
+                c.id AS course,
+                cr.date AS date,
+                cr.id AS criteriaid,
+                ra.userid AS userid
+            FROM
+                {course_completion_criteria} cr
+            INNER JOIN
+                {course} c
+             ON cr.course = c.id
+            INNER JOIN
+                {context} con
+             ON con.instanceid = c.id
+            INNER JOIN
+                {role_assignments} ra
+             ON ra.contextid = con.id
+            LEFT JOIN
+                {course_completion_crit_compl} cc
+             ON cc.criteriaid = cr.id
+            AND cc.userid = ra.userid
+            WHERE
+                cr.criteriatype = '.COMPLETION_CRITERIA_TYPE_DURATION.'
+            AND con.contextlevel = '.CONTEXT_COURSE.'
+            AND c.enablecompletion = 1
+            AND cc.id IS NULL
+            AND ra.timestart + cr.enrolperiod < ?
+        ';
+
+        // Loop through completions, and mark as complete
+        if ($rs = $DB->get_recordset_sql($sql, array(time()))) {
+            foreach ($rs as $record) {
+
+                $completion = new completion_criteria_completion((array)$record);
+                $completion->mark_complete();
+            }
+
+            $rs->close();
+        }
+    }
+}
